//
// $Id: App.hh 16 2005-05-15 13:07:27Z raphael $
//

#ifndef __PBS_APP_H
#define __PBS_APP_H

#include <ctime>

#include "Config.hh"
#include "Effect.hh"

class App {
public:
  App(Config *cfg);
  
  void run(int argc, char* argv[]);
  void end();
  
  void initOpengl(int argc, char* argv[]);
  
  static App *getInstance();

  void displayFunc();
  void idleFunc();
  void reshapeFunc(int w, int h);
  void keyboardFunc(unsigned char key, int x, int y);

private:
  Config *_config;
  Effect *_effect;

  static App *_instance;

  long _frame;
  time_t _start;
};

//
//
void wrapDisplayFunc();
void wrapIdleFunc();
void wrapReshapeFunc(int w, int h);
void wrapKeyboardFunc(unsigned char key, int x, int y);

#endif // __PBS_APP_H

