//
// $Id: Config.cc 43 2005-06-23 06:13:12Z raphael $
//

#include <unistd.h>
#include <iostream>

#include "Config.hh"

Config::Config(int argc, char *argv[]) {
  // set defaults
  _width = 640;
  _height = 480;
  _fullscreen = false;
  _water = 128;
  
  // set cmdline
  int op;
  while((op = getopt(argc, argv, "fw:h:s:")) != EOF) {
    switch(op) {
    case 'f':
      _fullscreen = true;
      break;
    case 'w':
      _width = atoi(optarg);
      break;
    case 'h':
      _height = atoi(optarg);
      break;
    case 's':
      _water = atoi(optarg);
      break;
    default:
      break;
    }
  }
}

bool Config::isFullscreen() {
  return _fullscreen;
}

int Config::getWidth() {
  return _width;
}

int Config::getHeight() {
  return _height;
}

void Config::resize(int w, int h) {
  _width = w;
  _height = h;
}

int Config::waterSize() {
  return _water;
}
