//
// $Id: Effect.hh 37 2005-06-18 06:05:24Z raphael $
//

#ifndef __PBS_EFFECT_H
#define __PBS_EFFECT_H

#include <GL/freeglut.h>

#include "Config.hh"
#include "Particles.hh"
#include "Water.hh"

class Effect {
public:
  Effect(Config *cfg);

  void displayFunc();
  void reshapeFunc(int w, int h);

  void background();

  void init();

  void angleInc();
  void angleDec();

  void particleRateInc();
  void particleRateDec();
  void particleSizeInc();
  void particleSizeDec();

  void resetWater();
  void wfWater();

private:
  Config *_config;
  ParticleSystem *_system;
  Water *_water;

  GLfloat _frustrum;
  GLfloat _angle;
  GLint _w, _h;

  long int _tm_sec;
  unsigned short _tm_msec;
  
  float _dt;

  void initScene();

  GLuint _model;
  GLuint _texture;

  GLfloat _mat_shininess[1];
  GLfloat _mat_specular[4];
  GLfloat _mat_diffuse[4];
};

#endif // __PBS_EFFECT_H

