//
// $Id: Particles.hh 39 2005-06-18 08:59:33Z raphael $
//

#ifndef __PBS_PARTICLES_H
#define __PBS_PARTICLES_H

#include <deque>

#include "Water.hh"

typedef struct TParticle {
  float F[3];
  float m;
  float pos[3];
  float v[3];
  float birth;
  bool  alive;
  float phi;
} Particle;

class ParticleSystem {

 public:
  ParticleSystem(Water *water);

  void init();
  void update(float dt);
  void draw();

  void rateInc();
  void rateDec();

  void sizeInc();
  void sizeDec();

 private:
  void forces(Particle *p);

  std::deque<Particle> _particles;

  float _time, _timeLast;
  float _damping;
  float _lifetime;
  float _rate;

  float _psize;

  GLuint _texture;

  Water *_water;
};

#endif // __PBS_PARTICLES_H
