//
// $Id: Water.hh 43 2005-06-23 06:13:12Z raphael $
//

#ifndef __PBS_WATER_H
#define __PBS_WATER_H

#include <GL/freeglut.h>

typedef struct TWater {
  float v;
  float u[3];
  float n[3];
} WaterElem;

class Water {
public:
  Water();

  void init(GLuint bgTex, int w);
  void update(float dt);
  void draw();
  void drop(GLfloat pos[3]);
  void reset();
  void toggleWF();

private:
  int _width;
  WaterElem **_map;
  float _h, _c, _k;

  int _wireframe;

  GLuint _texture;
};

#endif // __PBS_WATER_H

